/**
 * @copyright 2015 Tridium, Inc. All Rights Reserved.
 * @author Danesh Kamal
 */

/**
 * @module nmodule/alarm/rc/db/commands/PlayCommand
 * @private
 */
define(['baja!',
  'jquery',
  'lex!alarm',
  'dialogs',
  'nmodule/alarm/rc/Alarm',
  'bajaux/commands/Command',
  'bajaux/commands/ToggleCommand'
], function (baja, $, lexs, dialogs, Alarm, Command, ToggleCommand) {

  "use strict";

  var ticket,
      REFRESH_INTERVAL = 5000,
      lex              = lexs[0];

  var PlayCommand = function (view, params, func) {
    ToggleCommand.call(this, params, func);
    this.view = view;
  };

  //extend and set up prototype chain
  PlayCommand.prototype = Object.create(ToggleCommand.prototype);
  PlayCommand.prototype.constructor = PlayCommand;

  PlayCommand.prototype.toggle = function (params) {

    ToggleCommand.prototype.toggle.call(this, params);
    var pager = this.view.pager;

    if (ticket) {
      ticket.cancel();
    }

    if (this.isSelected() && pager) {
      pager.updateTable().then(function () {
        ticket = baja.clock.schedulePeriodically(function () {
          pager.updateTable();
        }, REFRESH_INTERVAL);
      });
    }
  };

  PlayCommand.makeFor = function (view) {
    return new PlayCommand(view, {
      displayName: lex.get('command.play.label'),
      description: lex.get('command.play.label'),
      icon: lex.get('command.play.icon')
    });
  };

  return PlayCommand;

});
